#ifndef	ultrix	/* this file for non-ultrix systems */
# include	<sys/vm.h>
#ifdef NEVER
# ifdef BSD42
# include	<vax/pte.h>
# else
# include	<machine/pte.h>
# endif
#endif
# include	"pmon.h"


#define	BSD42	on

/*
** GETUPAGE - Reads the upage for the specified process as well as sufficient
** page tables entries for reading the command arguments. The pte's are read
** into the argument `ptetbl'. The upage is read into the external variable
** `User'. This procedure returns 1 if the upage was successfully read.
*/

getupage ( p )

register struct proc		*p ;

{
	register int		i ;
	register int		ncl ;
	struct pte		pte ;
#ifdef	selport
/*	struct pte arguutl[UPAGES];*/
	struct pte	ptetbl[UPAGES];
#else	NOT selport
/*	struct pte arguutl[UPAGES+CLSIZE];*/
	struct pte	ptetbl[ UPAGES + CLSIZE ] ;
#endif	selport

	/* Phil: vax has size = sflg ? ctob(UPAGES) : sizeof (struct user); */
	/*
	 * If the process is not loaded, look for the upage
	 * on the swap device
	 */
	if ( !(p->p_flag & SLOAD) )
	{				
# ifdef BSD42 /* Should be on for gould */
		lseek( swap, (long)dtob( p->p_swaddr ), 0 ) ;
# else
		lseek( swap, (long)ctob( p->p_swaddr ), 0 ) ;
# endif
		if ( read( swap, (char*)&user.user, sizeof( struct user ) )
		!= sizeof( struct user ) )
		{
			fprintf( stderr,
				"pmon - Can't read upage of process %d\n",
			    p->p_pid ) ;
			return ( 0 ) ;
		}
		return ( 1 ) ;		
	}				
#ifndef selport
	/*
	 * The process is loaded. Locate the process pte's by reading
	 *  the pte of their base address from system virtual address space.
	 */
	lseek( kmem, (long)&Usrptmap[ btokmx(p->p_p0br) + p->p_szpt-1 ], 0 ) ;
	if ( read( kmem, (char*)&pte, sizeof( struct pte ) )
	!= sizeof( struct pte ) )
	{
		fprintf( stderr,
		      "pmon - Can't read indir pte for upage of process %d\n",
		    p->p_pid ) ;
		return ( 0 ) ;
	}				
	/*
	 * Now read the process' pte's from physical memory. We need to access
	 * sufficient pte's for the upage and for the command arguments.
	 */
	lseek( mem, (long)ctob( pte.pg_pfnum+1 )
		- (UPAGES+CLSIZE)*sizeof( struct pte ), 0 ) ;
	if ( read( mem, (char*)ptetbl, (UPAGES+CLSIZE)*sizeof( struct pte ) )
	!= (UPAGES+CLSIZE)*sizeof( struct pte ) )
	{
		fprintf( stderr, "pmon - Can't read page table of process %d\n",
			p->p_pid ) ;
		return ( 0 ) ;
	}
	/* PHIL - The vax has some funny stuff here */
	/*
	 * Now we can read the pages belonging to the upage.
	 * Here we read in an entire click at one go.
	 */
	ncl = (sizeof( struct user ) + NBPG*CLSIZE - 1) / (NBPG*CLSIZE) ;
	while ( --ncl >= 0 )		
	{				
		i = ncl * CLSIZE ;
		lseek( mem, (long)ctob( ptetbl[ CLSIZE+i ].pg_pfnum ), 0 ) ;
		if ( read( mem, user.upages[i], CLSIZE*NBPG ) != CLSIZE*NBPG )
		{
			fprintf( stderr,
				"pmon - Can't read page 0x%x of process %d\n",
				ptetbl[ CLSIZE+i ].pg_pfnum, p->p_pid ) ;
			return ( 0 ) ;
		}
	}

#else	selport		Get the SEL-style info

	/*
	 * This gets the pte of the proc's u.
	 */

	lseek( kmem, (char *)p->p_addr, 0 ) ;
	if ( read( kmem, (char *)ptetbl, sizeof( ptetbl ) )
	!= sizeof( ptetbl ) )
	{
		fprintf( stderr,
		      "pmon - Can't read page table for upage of process %d\n",
		    p->p_pid ) ;
		return ( 0 ) ;
	}				

	/*
	 * This gets the pte of the highest-addressed stack page.
	 * Said page contains, we hope, the arguments.
	 */

	lseek( kmem, (char *)(p->p_p0br - 1), 0 ) ;
	if ( read( kmem, (char *)&pte, sizeof( pte ) )
	!= sizeof( pte ) )
	{
		fprintf( stderr,
		      "pmon - Can't read indir pte for upage of process %d\n",
		    p->p_pid ) ;
		return ( 0 ) ;
	}				

	/*
	 * SEL: has different way of looking at u, so fancy clustering
	 * stuff is just ignored for now, especially since SEL clustering
	 * is 1 and will probably be for some time.
	 */

	i = UPAGES;
	while (--i >= 0)
	{
		lseek( mem, (long)ctob(ptetbl[i].pg_pfnum), 0);
		if (read( mem, user.upages[i], UPAGES*NBPG) != UPAGES*NBPG)
		{
			printf("ps: cant read page %d of u of pid %d\n",
/* 32nix: add SWD change (CBR 131) */
			    ptetbl[i].pg_pfnum, p->p_pid );
			return(0);
		}
	}
#endif	NOT selport

	return ( 1 ) ;
}
#endif	ultrix	/* this file for non-ultrix systems */
